﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace UpdatingSQL
{
    
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        //initialize all classes
        SqlConnection con = new SqlConnection();
        SqlCommand cmd = new SqlCommand();
        SqlDataAdapter da = new SqlDataAdapter();
        DataTable dt = new DataTable();
        //Declare a variable
        string query;
        int userid;


        private void Retrieve_Data()
        {

            try
            {
                //create a query for retrieving data in the database.
                query = "SELECT ID as 'Id',NAME as 'Name',UNAME as 'Username',PASS, UROLE as 'Role'  FROM tbluser";
                //initialize new Sql commands
                cmd = new SqlCommand();
                //hold the data to be executed.
                cmd.Connection = con;
                cmd.CommandText = query;
                //initialize new Sql data adapter
                da = new SqlDataAdapter();
                //fetching query in the database.
                da.SelectCommand = cmd;
                //initialize new datatable
                dt = new DataTable();
                //refreshes the rows in specified range in the datasource. 
                da.Fill(dt);
                //set the data that to be display in the datagridview
                dataGridView1.DataSource = dt;

                //Hidding the column pass for the security used
                dataGridView1.Columns["PASS"].Visible = false;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                da.Dispose();
             
            }
        }

        
        private void Form1_Load(object sender, EventArgs e)
        {
            //connection between sql server to c#
            con.ConnectionString = "Data Source=.\\SQLEXPRESS;Database=cruddb;trusted_connection=true;";
            //Call a method for retrieving data in the database to the datagridview
            Retrieve_Data();

        }

        private void btnsave_Click(object sender, EventArgs e)
        {
            try
            {
                //opening connection
                con.Open();
                //create an insert query;
                query = "UPDATE tbluser SET NAME='" + txtname.Text + "',UNAME='" + txtuname.Text + "',PASS='" + txtpass.Text + "',UROLE='" + cboRole.Text + "' WHERE ID=" + userid;
                //it holds the data to be executed.
                cmd.Connection = con;
                cmd.CommandText = query;
                //execute the data.
                int result = cmd.ExecuteNonQuery();
                //validate if the result of the executed query.
                if (result > 0)
                {
                    MessageBox.Show("Data has been updated in the SQL database");
                    //Call a method for retrieving data in the database to the datagridview
                    Retrieve_Data();

                    userid =0;
                    txtname.Text = "";
                    txtuname.Text = "";
                    txtpass.Text = "";
                    cboRole.Text = "Select";

                }
                else
                {
                    MessageBox.Show("SQL QUERY ERROR");
                }
                //closing connection
                con.Close();

            }
            catch (Exception ex)//catch exeption
            {
                //displaying error message.
                MessageBox.Show(ex.Message);
            }
        }

        private void dataGridView1_DoubleClick(object sender, EventArgs e)
        {
            //diplay the specific data from the datagridview to the textbox 
            try
            {
                userid = Int32.Parse( dataGridView1.CurrentRow.Cells["Id"].FormattedValue.ToString ());
                txtname.Text = dataGridView1.CurrentRow.Cells["Name"].FormattedValue.ToString ();
                txtuname.Text = dataGridView1.CurrentRow.Cells["Username"].FormattedValue.ToString ();
                txtpass.Text = dataGridView1.CurrentRow.Cells["PASS"].FormattedValue.ToString ();
                cboRole.Text = dataGridView1.CurrentRow.Cells["Role"].FormattedValue.ToString ();
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);

            }
        }

        
    }
}
